//------------------------------------------------------------------
//------------------------------------------------------------------
//-------Einfgen der Bibliotheken----------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------
#define  F_CPU 3686400     // Taktfrequenz des myAVR-Boards
#include <avr/io.h>        // Grundbibliothek
#include <stdio.h>         // Bibliothek fr Sprnge
#include <avr/interrupt.h> // Bibliothek fr Interrups
//------------------------------------------------------------------
//------------------------------------------------------------------
//-------Variablendeklaration---------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------
int empfangsfach=0;
int kopie_pinb;
int empf_bits=0;
int wartezeit_f_n_bit=0;
int dummy;
int wartezeit;
int fl_ausgewertet=0;
//------------------------------------------------------------------
//------------------------------------------------------------------
//-------Unterprogramme---------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------
void initialisierung()
{
  //Ausgnge--------------------------------------------------------
  DDRB   |=  (1<<1);
  //Eingnge--------------------------------------------------------
  DDRB   &= ~(1<<0);       // B.0 als Eingang initialisieren
  PORTB  |=  (1<<0);       // B.0 Pull Up
  DDRD &= (3<<2);		   //D.2 und D.3 = Eingang
  PORTD|= (3<<2);		   //D.2 und D.3 = PullUP
  //UART-Kommunikation----------------------------------------------
  UBRRL   = 23;            // 9600Baud siehe Baudratentabelle
  UCSRB  |= (1<<3);        // UDRE=Bit3, TX aktivieren
  //ISR's-----------------------------------------------------------
  GICR |= (1<<6);		   //INT0=D.2 ein
  MCUCR|= (1<<1);		   //reagiert auf fallende Flanke
	
  GICR |= (1<<7);		   //INT1=D.3 ein
  MCUCR|= (3<<2);		   //reagiert auf steigende Flanke

}
//------------------------------------------------------------------
void putChar(char data)
{
    // warte bis UDR leer ist UCSRA / USR bei z.B.: 2313
    while (bit_is_clear (UCSRA, 5)) {}
    // sende
    UDR = data;
}
//------------------------------------------------------------------
//------------------------------------------------------------------
//-------Interrupt-Service-Routinen---------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------
ISR (INT0_vect)	// fr Int0
{
  empfangsfach=empfangsfach*2;// alle Bits eine Stelle nach links
  empfangsfach|=(1<<0);       // Eintrag der 1 in das linke Bit
  fl_ausgewertet=1;
}

ISR (INT1_vect)	//fr Int1
{
  empfangsfach=empfangsfach*2;// alle Bits eine Stelle nach links
  fl_ausgewertet=1;
}
//------------------------------------------------------------------
//------------------------------------------------------------------
//-------Hauptprogramm----------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------
int main (void)
{
  initialisierung();         // Aufruf Unterprogramm

  while(1)                   // Endlosschleife
  {
    if (bit_is_clear(PIND,2))// Erkennung Telegrammbeginn
    {
      empfangsfach|=(1<<0);  // Eintrag des Startbits in
                             // in Empfangsfach
      anfang:
	  fl_ausgewertet=0;

	  for (wartezeit = 0;wartezeit<=3111;wartezeit++)
                             // ca. 3/4 Periodendauer
  	  {
        dummy=1;
  	  }
      
      kopie_pinb=PINB;       // Kopie fr anschl. Fl.-Erkennung

	  for (wartezeit_f_n_bit = 0;wartezeit_f_n_bit<=12444;wartezeit_f_n_bit++)
	                                         // ca. 1/2 Periodendauer
      {
	    sei();
	    if (fl_ausgewertet==1)
	    {
	      cli();
	      goto anfang;
        }
        cli();	    
	  }

	}
	//empfangsfach=empfangsfach/12;
	//putChar(empfangsfach);

  }                         // Ende While (1)
}   
